biostar/urls.py
from django.conf.urls import patterns, include, url
from django.conf import settings

# Uncomment the next two lines to enable the admin:
from django.contrib import admin
admin.autodiscover()

from django.views.generic import TemplateView
from biostar.server import views, ajax, search, moderate, api, orcid
from biostar.apps.posts.views import NewAnswer, NewPost, EditPost, poll_submit, external_post_handler, get_augmented_link
from biostar.apps.users.views import external_logout, external_login, CaptchaView, DigestManager, unsubscribe
from biostar.apps.planet.views import BlogPostList

urlpatterns = patterns('',

    # Post listing.
    url(r'^$', views.PostList.as_view(), name="home"),

    # Listing of all tags.
    url(r'^t/$', views.TagList.as_view(), name="tag-list"),

    # Badge view details.
    url(r'^b/(?P<pk>\d+)/$', views.BadgeView.as_view(), name="badge-view"),

    # Badge list details.
    url(r'^b/list/$', views.BadgeList.as_view(), name="badge-list"),

    # Topic listing.
    url(r'^t/(?P<topic>.+)/$', views.PostList.as_view(), name="topic-list"),

    # The list of users.
    url(r'^user/list/$', views.UserList.as_view(), name="user-list"),

    # User details.
    url(r'^u/(?P<pk>\d+)/$', views.UserDetails.as_view(), name="user-details"),

    # User details.
    url(r'^u/edit/(?P<pk>\d+)/$', views.EditUser.as_view(), name="user-edit"),

    # Post details.
    url(r'^p/(?P<pk>\d+)/$', views.PostDetails.as_view(), name="post-details"),

    # Change subscription view.
    url(r'^local/sub/(?P<pk>\d+)/(?P<type>\w+)/$', views.ChangeSub.as_view(), name="change-sub"),

    # A separate url for each post type.
    url(r'^p/new/post/$', views.RateLimitedNewPost.as_view(), name="new-post"),

    # A new external post
    url(r'^p/new/external/post/$', external_post_handler, name="new-external-post"),

    url(r'^p/new/answer/(?P<pid>\d+)/$', views.RateLimitedNewAnswer.as_view(post_type="answer"), name="new-answer"),
    url(r'^p/new/comment/(?P<pid>\d+)/$', views.RateLimitedNewAnswer.as_view(post_type="comment"), name="new-comment"),

    # Edit an existing post.
    url(r'^p/edit/(?P<pk>\d+)/$', EditPost.as_view(), name="post-edit"),

    # Poll submission.
    url(r'^poll/submit/(?P<pk>\d+)/(?P<question_ids>[\[,\d \]]+)$', poll_submit, name="poll-submit"),

    # Message display.
    url(r'^local/messages/$', views.MessageList.as_view(), name="user-messages"),

    # Vote display.
    url(r'^local/votes/$', views.VoteList.as_view(), name="user-votes"),

    # Produces the moderator panel.
    url(r'^local/moderate/post/(?P<pk>\d+)/$', moderate.PostModeration.as_view(), name="post-moderation"),

    # Produces the moderator panel.
    url(r'^local/moderate/user/(?P<pk>\d+)/$', moderate.UserModeration.as_view(), name="user-moderation"),

    # Full login and logout
    url(r'^site/login/$', external_login, name="login"),
    url(r'^site/logout/$', external_logout, name="logout"),
    url(r'^accounts/signup/$', CaptchaView.as_view(), name="signup"),

    # Email handlers
    url(r'^local/email/', views.email_handler, name="email-handler"),

    # Search the body.
    url(r'^local/search/page/', search.Search.as_view(), name="search-page"),

    # Search the titles.
    url(r'^local/search/title/', search.search_title, name="search-title"),

    # Digest news manager.
    url(r'^digest/manage/', DigestManager.as_view() , name="digest_manage"),
    url(r'^digest/unsubscribe/(?P<uuid>\w+)/', unsubscribe , name="digest_unsubscribe"),

    # Returns suggested tags
    url(r'^local/search/tags/', search.suggest_tags, name="suggest-tags"),


    # Returns the planet view
    url(r'^planet/$', BlogPostList.as_view(), name="planet"),

    # Vote submission.
    url(r'^x/vote/$', ajax.vote_handler, name="vote-submit"),

    # Rating submission.
    url(r'^x/rate/$', ajax.rate_handler, name="rate-submit"),

    # Get ratings for current user
    url(r'^x/get_user_ratings/$', ajax.get_user_ratings, name="get-user-ratings"),
    
    # Cancel ratings for current user
    url(r'^x/cancel_ratings/$', ajax.cancel_ratings, name="cancel-ratings"),

    # ajax debug
    url(r'^ajax/debug/$', ajax.set_debug_ajax, name="debug-ajax"),

    url(r'^ajax/get_augmented_link/$', get_augmented_link, name='get_augmented_link'),

    # Social login pages.
    url(r'^accounts/social/orcid/import/$', orcid.import_bio, name="orcid-import"),
    (r'^accounts/', include('allauth.urls')),

    # Redirecting old posts urls from previous versions of Biostar
    url(r'^post/redirect/(?P<pid>\d+)/$', views.post_redirect),
    url(r'^post/show/(?P<pid>\d+)/$', views.post_redirect),
    url(r'^post/show/(?P<pid>\d+)/([-\w]+)/$', views.post_redirect),
    url(r'^questions/(?P<pid>\d+)/$', views.post_remap_redirect),
    url(r'^questions/(?P<pid>\d+)/([-\w]+)/$', views.post_remap_redirect),
    url(r'^questions/tagged/(?P<tag>.+)/$',views.tag_redirect),

    # Api.
    url(r'^api/traffic/$', api.traffic, name='api-traffic'),
    url(r'^api/user/(?P<id>\d+)/$', api.user_details, name='api-user'),
    url(r'^api/post/(?P<id>\d+)/$', api.post_details, name='api-post'),
    url(r'^api/vote/(?P<id>\d+)/$', api.vote_details, name='api-vote'),
    url(r'^api/stats/day/(?P<day>\d+)/$', api.daily_stats_on_day, name='api-stats-on-day'),
    url(r'^api/stats/date/(?P<year>\d{4})/(?P<month>\d{2})/(?P<day>\d{2})/$',
        api.daily_stats_on_date, name='api-stats-on-date'),

    # Uncomment the next line to enable the admin:
    url(r'^admin/', include(admin.site.urls)),

     # Local robots.txt.
    url(r'^robots\.txt$', TemplateView.as_view(template_name="robots.txt", content_type='text/plain'), name='robots'),

)

# Adding the sitemap.
urlpatterns += patterns('',
    (r'^sitemap\.xml$', 'django.contrib.sitemaps.views.sitemap', {'sitemaps': search.sitemaps})
)

from biostar.server.feeds import LatestFeed, TagFeed, UserFeed, PostFeed, PostTypeFeed, PlanetFeed

# Adding the RSS related urls.
urlpatterns += patterns('',

    # RSS info page.
    url(r'^info/rss/$', views.RSS.as_view(), name='rss'),

    # RSS feeds
    url(r'^feeds/latest/$', LatestFeed(), name='latest-feed'),

    url(r'^feeds/tag/(?P<text>[\w\-_\+!]+)/$', TagFeed(), name='tag-feed'),
    url(r'^feeds/user/(?P<text>[\w\-_\+!]+)/$', UserFeed(), name='user-feed'),
    url(r'^feeds/post/(?P<text>[\w\-_\+!]+)/$', PostFeed(), name='post-feed' ),
    url(r'^feeds/type/(?P<text>[\w\-_\+!]+)/$', PostTypeFeed(), name='post-type'),
    url(r'^feeds/planet/$', PlanetFeed(), name='planet-feed'),
)

urlpatterns += patterns('',
    url(r'^info/(?P<slug>\w+)/$', views.FlatPageView.as_view(), name='flatpage'),
    url(r'^info/update/(?P<pk>\d+)/$', views.FlatPageUpdate.as_view(), name='flatpage-update'),
)

# This is used only for the debug toolbar
if settings.DEBUG:
    import debug_toolbar
    from biostar.apps.users.views import test_login
    urlpatterns += patterns('',
        url(r'^__debug__/', include(debug_toolbar.urls)),
        url(r'^test/login/', test_login),
    )

biostar/apps/posts/models.py
from __future__ import print_function, unicode_literals, absolute_import, division
import logging, datetime, string
from django.db import models
from django.conf import settings
from django.contrib import admin
from django.contrib.sites.models import Site

from django.utils.timezone import utc
from django.utils.translation import ugettext_lazy as _
from django.core.urlresolvers import reverse
import bleach
from django.db.models import Q, F
from django.core.exceptions import ObjectDoesNotExist
from biostar import const
from biostar.apps.util import html
from biostar.apps import util
import re

# HTML sanitization parameters.

logger = logging.getLogger(__name__)

def now():
    return datetime.datetime.utcnow().replace(tzinfo=utc)

class Tag(models.Model):
    name = models.TextField(max_length=50, db_index=True)
    count = models.IntegerField(default=0)
    
    # What site does the tag belong to.
    site = models.ForeignKey(Site, null=True, db_index=True)

    @staticmethod
    def fixcase(name):
        return name.upper() if len(name) == 1 else name.lower()

    @staticmethod
    def update_counts(sender, instance, action, pk_set, *args, **kwargs):
        "Applies tag count updates upon post changes"

        if action == 'post_add':
            Tag.objects.filter(pk__in=pk_set).update(count=F('count') + 1)

        if action == 'post_remove':
            Tag.objects.filter(pk__in=pk_set).update(count=F('count') - 1)

        if action == 'pre_clear':
            instance.tag_set.all().update(count=F('count') - 1)

    def __unicode__(self):
        return self.name

class TagAdmin(admin.ModelAdmin):
    list_display = ('name', 'count')
    search_fields = ['name']


admin.site.register(Tag, TagAdmin)

class PostManager(models.Manager):

    def my_bookmarks(self, user, request=None):
        site = self.get_site(request)
        if site:
            query = self.filter(votes__author=user, votes__type=Vote.BOOKMARK, site=site)
        else:
            query = self.filter(votes__author=user, votes__type=Vote.BOOKMARK)
        query = query.select_related("root", "author", "lastedit_user")
        query = query.prefetch_related("tag_set")
        return query

    def my_posts(self, target, user, request=None):

        site = self.get_site(request)

        # Show all posts for moderators or targets
        if user.is_moderator or user == target:
            if site is None:
                query = self.filter(author=target)
            else:
                query = self.filter(author=target, site=site)
        else:
            if site is None:
                query = self.filter(author=target).exclude(status=Post.DELETED)
            else:
                query = self.filter(author=target, site=site).exclude(status=Post.DELETED)

        query = query.select_related("root", "author", "lastedit_user")
        query = query.prefetch_related("tag_set")
        query = query.order_by("-creation_date")
        return query

    def fixcase(self, text):
        return text.upper() if len(text) == 1 else text.lower()

    def tag_search(self, text, request=None):
        "Performs a query by one or more , separated tags"
        include, exclude = [], []
        # Split the given tags on ',' and '+'.
        terms = text.split(',') if ',' in text else text.split('+')
        for term in terms:
            term = term.strip()
            if term.endswith("!"):
                exclude.append(self.fixcase(term[:-1]))
            else:
                include.append(self.fixcase(term))

        site = self.get_site(request)

        if include:
            query = self.filter(type__in=Post.TOP_LEVEL, tag_set__name__in=include, site=site).exclude(
                tag_set__name__in=exclude)
        else:
            query = self.filter(type__in=Post.TOP_LEVEL, site=site).exclude(tag_set__name__in=exclude)

        query = query.filter(status=Post.OPEN).exclude(type=Post.EDIT_HISTORY)

        # Remove fields that are not used.
        query = query.defer('content', 'html')

        # Get the tags.
        query = query.select_related("root", "author", "lastedit_user").prefetch_related("tag_set").distinct()

        return query

    def get_thread(self, root, user, sort_order="types"):
        # Populate the object to build a tree that contains all posts in the thread.
        is_moderator = user.is_authenticated() and user.is_moderator
        order_by = ["type", "-has_accepted", "-quality", "-vote_count", "creation_date"]
        if sort_order == "votes":
            order_by = ["-quality", "-vote_count", "type", "-has_accepted", "creation_date"]
        elif sort_order == "quality":
            order_by = ["-quality", "type", "-has_accepted", "creation_date"]
        elif sort_order == "relevance":
            order_by = ["-relevance", "type", "-has_accepted", "creation_date"]
        elif sort_order == "level_of_agreement":
            order_by = ["-level_of_agreement", "type", "-has_accepted", "creation_date"]
        elif sort_order == "creation_dates":
            order_by = ["creation_date", "-quality", "-vote_count", "type", "-has_accepted"]
        
        cond = Q(root=root) & ~Q(pk=root.pk) & ~Q(type__in=Post.POLL_TYPES)

        if not is_moderator:
            cond &= ~Q(status=Post.DELETED)

        query = self.filter(cond).select_related("root", "author", "lastedit_user").order_by(*order_by)

        return query

    def top_level(self, user, request=None):
        "Returns posts based on a user type"
        is_moderator = user.is_authenticated() and user.is_moderator
        
        site = self.get_site(request)

        if is_moderator:
            query = self.filter(type__in=Post.TOP_LEVEL, site=site).exclude(type=Post.EDIT_HISTORY)
        else:
            query = self.filter(type__in=Post.TOP_LEVEL, site=site).exclude(status=Post.DELETED).exclude(type=Post.EDIT_HISTORY)

        return query.select_related("root", "author", "lastedit_user").prefetch_related("tag_set").defer("content", "html")

    def get_site(self, request):
        site = None
        if request:

            domain = request.subdomain

            if not domain and request.META.has_key('HTTP_HOST'):
                http_host = request.META['HTTP_HOST']
                domain, n_replacements = re.subn(r"\.[a-z-]+\.[a-z]+$", '', http_host)
                if n_replacements == 0:
                    domain = ''
            if domain and len(domain) > 0:
                try:
                    site = Site.objects.get(domain=domain)
                except ObjectDoesNotExist:
                    site = None
        return site

class Post(models.Model):
    "Represents a post in Biostar"
    
    def save_without_signals(self):
        """
        This allows for updating the model from code running inside post_save()
        signals without going into an infinite loop:
        """
        self._disable_signals = True
        self.save()
        self._disable_signals = False

    objects = PostManager()

    # Post statuses.
    PENDING, OPEN, CLOSED, DELETED, CERTIFIED = range(5)
    STATUS_CHOICES = [(PENDING, "Pending"), (OPEN, "Open"), (CLOSED, "Closed"), (DELETED, "Deleted"), (CERTIFIED, "Certified")]

    # Vote types
    # Experimental feature for research purpose only
    # When creating a post, the user chooses how this post will be rated
    UP, UP_DOWN, QUALITY, QUALITY_LOA, QUALITY_LOA_RELEVANCE, NONE = range(6)
    VOTE_TYPES = [(UP, "Up"), (UP_DOWN, "Up / Down"), (QUALITY, "Quality"), (QUALITY_LOA, "Quality, Level of agreement"), (QUALITY_LOA_RELEVANCE, "Quality, Level of agreement, Relevance"), (NONE, "None")]

    # Question types. Answers should be listed before comments.
    QUESTION, ARGUMENT_FOR, ARGUMENT_AGAINST, ANSWER, DEBATE, SURVEY, JOB, FORUM, PAGE, BLOG, COMMENT, DATA, TUTORIAL, BOARD, TOOL, NEWS, META, EDIT_HISTORY, EDIT, ARTICLE, TEMPLATE_ARTICLE, POLL_MULTIPLE_CHOICE, POLL_CHECKBOX, POLL_CHOICE = range(24)

    TYPE_CHOICES = [
        (QUESTION, "Question"), (ANSWER, "Answer"), (ARGUMENT_FOR, "Argument For"), (ARGUMENT_AGAINST, "Argument Against"), (COMMENT, "Comment"),
        (DEBATE, "Debate"), (SURVEY, "Survey"), (JOB, "Job"), (FORUM, "Forum"), (TUTORIAL, "Tutorial"), (META, "Meta"), (EDIT_HISTORY, "Edit History"), (EDIT, "Edit"),
        (DATA, "Data"), (PAGE, "Page"), (TOOL, "Tool"), (NEWS, "News"),
        (BLOG, "Blog"), (BOARD, "Bulletin Board"), (ARTICLE, "Article"), (TEMPLATE_ARTICLE, "Template Article"),
        (POLL_MULTIPLE_CHOICE, "Poll Multiple Choice"), (POLL_CHECKBOX, "Poll Checkbox"), (POLL_CHOICE, "Poll Choice")
    ]

    TOP_LEVEL = set((QUESTION, DEBATE, META, EDIT_HISTORY, SURVEY, JOB, FORUM, PAGE, BLOG, DATA, TUTORIAL, TOOL, NEWS, BOARD, ARTICLE, TEMPLATE_ARTICLE))
    POLL_TYPES = set((POLL_MULTIPLE_CHOICE, POLL_CHECKBOX, POLL_CHOICE))

    title = models.CharField(max_length=200, null=False)

    # The user that originally created the post.
    author = models.ForeignKey(settings.AUTH_USER_MODEL)

    # The user that edited the post most recently.
    lastedit_user = models.ForeignKey(settings.AUTH_USER_MODEL, related_name='editor')

    # Indicates the information value of the post.
    rank = models.FloatField(default=0, blank=True)

    # Post status: open, closed, deleted.
    status = models.IntegerField(choices=STATUS_CHOICES, default=OPEN)
    
    # Vote types: up, up / down, quality, quality + level of agreement, quality + level of agreement + relevance
    vote_types = models.IntegerField(choices=VOTE_TYPES, default=QUALITY)

    # The type of the post: question, answer, comment.
    type = models.IntegerField(choices=TYPE_CHOICES, db_index=True)

    # Number of upvotes minus number of downvotes for the post
    vote_count = models.IntegerField(default=0, blank=True, db_index=True)

    # Average relevance for the post
    relevance = models.FloatField(default=0, blank=True, db_index=True)

    # Number of relevance votes for the post

biostar/server/templates/badge_details.html
{% extends "starbase.html" %}
{% load i18n %}
{% load server_tags %}
{% load humanize %}

{% block page_title %}
    {% trans "Badge:" %} {{ badge.name }}
{% endblock %}

{% block content %}

    <div class="row">

        <div class="col-md-12">
            <h3>{% trans "Badge:" %} {{ badge.name }} <i class="{{ badge.icon }}"></i> &bull; <a
                    href="{% url 'badge-list' %}">All &raquo;</a></h3>

            <h4>{% blocktrans %}Awarded {{ badge.count }} time{{ badge.count|pluralize }} for: <em>{{ badge.desc }}</em>{% endblocktrans %}</h4>

            <h4>{% trans "Recently awarded to" %} </h4>

            {% for award in awards %}

                <div class="col xs-3 col-md-2 text-center" style="height:250px;">
                    <div>{% gravatar award.user 82 %}</div>
                    <div class="ago">{{ award.date|time_ago }} {% trans "to" %}</div>
                    <div class="uname">{% userlink award.user %}</div>
                    <div class="loc">{{ award.user.profile.location }}</div>
                    {% if award.context %}
                        <div class="">For: {{ award.context|safe }}</div>
                    {% endif %}
                </div>

            {% endfor %}

        </div>

{% endblock %}

biostar/server/templates/email_list_form.html
{% extends "starbase.html" %}
{% load i18n %}
{% load server_tags %}
{% load humanize %}
{% load crispy_forms_tags %}

{{ SITE_DOMAIN }}{% trans "Email list subscription" %}

{% block content %}

    <div class="row">

        <div class="col-md-4 col-md-offset-4">
            <h2>{% trans "Update Email List Settings" %}</h2>
            {% crispy form %}
        </div>

    </div>

{% endblock %}

biostar/server/templates/pagedown_widget.html
{% load i18n %}
<div class="">
    <div class="wmd-panel">
        <div id="wmd-button-bar"></div>
         <textarea class="wmd-input" id="wmd-input" name="content" rows="{{ rows }}"
                   placeholder="{% trans "Type your post here" %}">{{ value }}</textarea>
    </div>
</div>

<div>
    <div id="wmd-preview" class="wmd-panel wmd-preview"></div>
</div>

biostar/server/templates/post_moderation_form.html
{% load humanize %}
{% load i18n %}
{% load crispy_forms_tags %}
<div class="alert alert-warning">

    <h4>{% blocktrans %}Moderating {{ post.get_type_display }}: {{ post.title }}{% endblocktrans %}</h4>

    {% crispy form %}

</div>

biostar/server/templates/user_details.html
{% extends "starbase.html" %}
{% load cache %}
{% load server_tags %}
{% load i18n %}
{% load humanize %}
{% load socialaccount %}

{% block page_title %}
    {% trans "User:" %} {{ target.name }}
{% endblock %}

{% block content %}

    <div class="row">

        <div class="col-md-12 user-details">

            <div class="col-md-12">
                <h2
                class="text-center {{ target.get_status_display }}">{{ target.get_type_display }}: {{ target.name }}</h2>


            </div>

            <div class="col-md-3">

                <div class="text-center">
                    {#  User gravatar.  #}
                    {% gravatar target 200 %}
                    <div>{% userlink target %}</div>
                </div>

                <div class="text-center" style="margin-top:20px">


                    {% if target.is_editable and user.is_moderator and user != target %}
                        <div style="margin-top:10px;">
                            <a role="button" class="btn btn-warning mod-user" data-value="{{ target.id }}">{% trans "Moderate
                                User" %}</a>
                        </div>
                    {% endif %}
                </div>

                {% if target.has_ownership %}
                    <div style="font-size: smaller; padding:0px 0px 20px 20px;">
                        {% blocktrans %}
                        Your portrait is loaded from <a href="http://www.gravatar.com">Gravatar</a> based
                        on your email. If you don't have a <a href="http://www.gravatar.com">Gravatar</a> account
                        your portait is
                        an "identicon": an automatically generated, unique image.
                        {% endblocktrans %}
                    </div>
                {% endif %}

            </div>

            {#  The short description entered by the user.  #}
            <div class="col-md-4">
                <dl class="dl-horizontal">


                    <dt>{% trans "Reputation:" %}</dt>
                    <dd><b>{{ target.scaled_score |intcomma }}</b></dd>

                    <dt>{% trans "Status:" %}</dt>
                    <dd>{{ target.get_status_display }}</dd>

                    {% if target.score > 0 or user.is_moderator %}
                        <dt>{% trans "Location:" %}</dt>
                        <dd>{{ target.profile.location }}</dd>



                        {% if target.profile.website %}
                            <dt>{% trans "Website:" %}</dt>
                            <dd>

                                <a rel="nofollow" href="{{ target.profile.website }}">
                                    {{ target.profile.website|truncatechars:25 }}</a>

                            </dd>
                        {% endif %}
                    {% endif %}


                    {% if target.profile.twitter_id %}
                        <dt>{% trans "Twitter:" %}</dt>
                        <dd>

                            <i class="fa fa-twitter"></i> <a rel="nofollow"
                                                             href="http://twitter.com/{{ target.profile.twitter_id }}">
                            {{ target.profile.twitter_id|truncatechars:25 }}</a>

                        </dd>
                    {% endif %}

                    {% if target.profile.scholar %}
                        <dt>{% trans "Scholar ID:" %}</dt>
                        <dd>
                            <a rel="nofollow"
                               href="http://scholar.google.com/citations?user={{ target.profile.scholar }}">{% trans "Google
                                Scholar Page" %}</a>
                        </dd>
                    {% endif %}



                    <dt>{% trans "Last seen:" %}</dt>
                    <dd>{{ target.profile.last_login|naturaltime }}</dd>

                    <dt>{% trans "Joined:" %}</dt>
                    <dd>{{ target.profile.date_joined|naturaltime }}</dd>

                    <dt>{% trans "Email:" %}</dt>
                    {% if target.has_ownership %}
                        <dd>{{ target.email }}</dd>
                    {% else %}
                        <dd>{{ target.email|hide_email }}</dd>
                    {% endif %}


                    {% if target.has_ownership %}

                        <dt>{% trans "My Tags:" %}</dt>
                        <dd>{{ target.profile.my_tags|truncatechars:25 }}</dd>

                        <dt>{% trans "Watched Tags:" %}</dt>
                        <dd>
                            {% for tag in target.profile.tags.all %}
                                {{ tag.name }},
                            {% endfor %}
                        </dd>

                        <dt>{% trans "Notifications:" %}</dt>
                        <dd>{{ target.profile.get_message_prefs_display }}</dd>


                        <dt>{% trans "Log in options:" %}</dt>
                        <dd>
                            <a role="button" class="btn btn-info btn-xs" href="{% url 'socialaccount_connections' %}">
                                {% trans "Social Login" %}</a>
                        </dd>

                        <dt style="margin-top:5px;">
                            {% trans "Profile settings:" %}
                        </dt>
                        <dd style="margin-top:5px;">
                            <a href="{% url "user-edit" target.id %}" class="btn btn-success btn-xs" role="button"
                               href="#">{% trans "Edit
                                Your Profile" %}</a>
                        </dd>

                        {% if orcid_profile_url and orcid_id %}
                            <dt style="margin-top:5px;">
                                {% trans "ORCID profile:" %}
                            </dt>
                            <dd style="margin-top:5px;">
                                <a href="{{ orcid_profile_url }}">{{ orcid_id }}</a>
                            </dd>
                        {% endif %}
                    {% endif %}
                </dl>
            </div>

            {#  User bio.  #}
            <div class="col-md-5">

                {% if target.score > 0 or user.is_moderator %}
                    {{ target.profile.info|safe }}
                {% else %}
                    <p>
                        {% trans "Profile information, website and location are
                        not shown for new users." %}
                    </p>
                    <p>
                        {% trans "This helps us discourage the inappropriate use of our site." %}
                    </p>
                {% endif %}

            </div>

            {#  Post list goes here #}
            <div class="col-md-12">
                <h4 class="text-center">{% blocktrans %}Posts by {{ target.name }}{% endblocktrans %}</h4>
                {% page_bar %}
            </div>
            <div class="col-md-12">
                <div id="post-list">
                    {% for post in posts %}
                    
                        {% post_count_box post post.peek %}
                    
                    {% empty %}

                        <div class="alert alert-info">{% trans "There are no results for this page." %}</div>

                    {% endfor %}
                </div>
            </div>

            {% cache 500 "award" target.id %}
                {#  Award list goes here #}
                <div class="col-md-12">
                    <h4 class="text-center">{% blocktrans %}Latest awards to {{ target.name }}{% endblocktrans %}</h4>
                </div>
                <div class="col-md-12">
                    <div id="award-list">
                        {% for award in awards %}
                            <div class="col-xs-4 award">

                                <a href="{% url "badge-view" award.badge.id %}">{{ award.badge.name }}
                                    <i class="{{ award.badge.icon }}"></i></a>
                                <span class="ago">{{ award.date|time_ago }}</span>,
                                {{ award.badge.desc }}.
                                {% if award.context %}
                                    {% trans "For" %} {{ award.context|safe }}
                                {% endif %}

                            </div>
                            {% empty %}
                            <div class="alert alert-info">{% trans "No awards yet. Soon to come :-)" %}</div>
                        {% endfor %}
                    </div>
                </div>
            {% endcache %}
        </div>
    </div>

{% endblock %}

biostar/server/templates/vote_list.html
{% extends "starbase.html" %}
{% load i18n %}
{% load server_tags %}
{% load humanize %}

{% block content %}

    {#  {% search_bar %} #}

    <div class="row">
        <div class="col-md-9">
            {% page_bar %}
            <table id="posts" class="table table-striped">
                {% for vote in votes %}
                    <tr>
                        <td>
                            {% blocktrans %}{{ vote.get_type_display }}, {{ vote.date|timesince }} ago for
                            the {{ vote.post.get_type_display|lower }}:{% endblocktrans %} <a
                        href="{{ vote.post.get_absolute_url }}">{{ vote.post.title }}</a>
                        </td>
                    </tr>

                {% endfor %}
            </table>
            {% page_bar %}
        </div>
        <div class="col-md-3 sidebar">
            <div class="head">{% trans "People voting on your posts" %}</div>
            {% sidebar_users people %}

        </div>
    </div>



{% endblock %}